#ifndef ATL_DSYSINFO_H
   #define ATL_DSYSINFO_H


#if (defined (ATL_ARCH_IBMzEC12) && (__ARCH__ >=11)) || (defined (ATL_ARCH_IBMzEC12) && defined (ATL_ARCH_IBMz13))
#error Cannot tune for EC12 and z13 or later architectures at the same time
#endif

#if (!defined (ATL_ARCH_IBMzEC12) && !defined (ATL_ARCH_IBMz13) && __ARCH__>=11)
#define ATL_ARCH_IBMz13
#endif

#if (!defined (ATL_ARCH_IBMzEC12) && !defined (ATL_ARCH_IBMz13))
#define ATL_ARCH_IBMz13
#endif

#if defined (ATL_ARCH_IBMzEC12)

#if defined (__LP64__)

#define ATL_MULADD
#define ATL_L1elts 8192
#define ATL_fplat  5
#define ATL_lbnreg 32
#define ATL_mmnreg 32
#define ATL_nkflop 3848163


#else

#define ATL_MULADD
#define ATL_L1elts 8192
#define ATL_fplat  5
#define ATL_lbnreg 32
#define ATL_mmnreg 16
#define ATL_nkflop 3851966

#endif

#elif defined (ATL_ARCH_IBMz13)

#if defined (__LP64__)

#define ATL_MULADD
#define ATL_L1elts 4096
#define ATL_fplat  8
#define ATL_lbnreg 64
#define ATL_mmnreg 16
#define ATL_nkflop 4540657


#else

#define ATL_MULADD
#define ATL_L1elts 4096
#define ATL_fplat  8
#define ATL_lbnreg 16
#define ATL_mmnreg 16
#define ATL_nkflop 5609683

#endif

#endif

#endif
